﻿local _, ns = ...

local C = ns.C
local L = ns.L

DefaultDB = {
	Version = 1,
	name = true,
	texture = true,
	arrow = true,
	ch = true,
	mytarget = true,
	sf = true,
	pvp = true,
	auto = true,
	killtexture = true,
	bufftext = true,
	po = true,
	hpcent = false,
	DetailType = 3,
	
	num = 1,
	mypotext = 1,
	KillPer = 0,
	buffz = 25,
	
	
	
	nScale = 0.7,
	tScale = 1,
	ov = 0.8,
	oh = 0.6,
	AlphaMult = 1,
	MaxAlpha = 1,
color = {
	["rgb0"] = {r=1, g=0, b=0}, 
    ["rgb1"] = {r=1, g=0, b=0}, 
    ["rgb2"] = {r=0.3, g=0, b=0.6},
	["rgb3"] = {r=0.2, g=0.3, b=0.6},
	["rgb4"] = {r=1, g=0.5, b=0},
	["rgb5"] = {r=0, g=1, b=1},
	["rgb6"] = {r=0, g=1, b=0},
	["rgb7"] = {r=1, g=0, b=1},
},

DctAura = {	
	[307443] = true,	--璀璨火花
	[307454] = true, 	--璀璨火花易伤

	}
}


----------ONLOAD EVENT---------
local loadFrame = CreateFrame("FRAME"); 
loadFrame:RegisterEvent("ADDON_LOADED"); 
loadFrame:RegisterEvent("PLAYER_LOGOUT"); 

function loadFrame:OnEvent(event, arg1)
	if not PlateColorDB then 
		PlateColorDB = DefaultDB
	else
		if PlateColorDB.Version ~= DefaultDB.Version then
			PlateColorDB = DefaultDB
			end
 	end
end
loadFrame:SetScript("OnEvent", loadFrame.OnEvent);
----------------------------------

local uicvars = CreateFrame("Frame")
uicvars:RegisterEvent("PLAYER_ENTERING_WORLD")
uicvars:HookScript("OnEvent", function(self, event)

SetCVar("nameplateGlobalScale", PlateColorDB.nScale)
SetCVar("nameplateSelectedScale", PlateColorDB.tScale)
SetCVar("nameplateLargerScale", PlateColorDB.tScale)
SetCVar("nameplateOverlapV", PlateColorDB.ov)
SetCVar("nameplateOverlapH", PlateColorDB.oh)
SetCVar("nameplateOccludedAlphaMult", PlateColorDB.AlphaMult)
SetCVar("nameplateMaxAlpha", PlateColorDB.MaxAlpha)
SetCVar("nameplateMinAlpha", PlateColorDB.MaxAlpha)
end)

hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
if PlateColorDB.texture == true then
	local bars=NamePlateDriverFrame:GetClassNameplateManaBar() 
	if bars then bars:SetStatusBarTexture(.9,.9,.9) end
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		if frame:IsForbidden() then return end
		unitFrame.healthBar:SetStatusBarTexture(.75,.75,.75)
	end
	end
end)


--血条右侧显示箭头
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
	if frame:IsForbidden() then return end
	if frame:GetName() then return end	
	if UnitName(frame.unit) == UnitName("Player") then return end	--防止自身
		if not frame.arrow then
			frame.arrow = frame:CreateTexture(nil, "PARENT")
			frame.arrow:SetTexture("Interface\\Addons\\PlateColor\\blue.tga")		-- 图标路径
			frame.arrow:SetPoint("right", frame.healthBar, "right", 45, 0)				-- 右方箭头位置
			frame.arrow:SetSize(50, 50)										-- 箭头大小
			frame.arrow:SetAlpha(0)
		end
		if UnitIsUnit(frame.displayedUnit, "target") and PlateColorDB.arrow ==  true and UnitName(frame.unit) ~= UnitName("Player") then
			frame.arrow:SetAlpha(1)
		else
			frame.arrow:SetAlpha(0)
		end
end)
--斩杀线
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
local zhansha
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local width = unitFrame.healthBar:GetWidth()
		local height = unitFrame.healthBar:GetHeight()
		local fsid,_,_,_,_,_,_,_,_,fsidtf = GetTalentInfo(1,3,1)	--法师判断第一行第三个天赋
	if PlateColorDB.auto == true then
		if IsSpellKnown(281000) or IsSpellKnown(280735) or IsSpellKnown(330334) or IsSpellKnown(330325) or IsSpellKnown(343294) then
		--281000武器斩杀35,280735狂暴斩杀35,330334武器判罪35,330325狂暴判罪35,343294邪DK灵魂收割,173243奥法弹幕橙or IsEquippedItem(173243)
		zhansha = 35
		elseif fsid == 22462 and fsidtf == true then	--灼烧之触
		zhansha = 30
		elseif IsSpellKnown(24275) or IsSpellKnown(163201) or IsSpellKnown(5308) or IsSpellKnown(32379) or IsSpellKnown(53351) or IsSpellKnown(320976) or IsSpellKnown(317349) or IsSpellKnown(317485) then
		--24275愤怒之锤,163201武器防斩杀20,5308狂暴斩杀20,32379牧师灭,53351兽王射击夺命,320976生存夺命,317349武器防判罪20,317485狂暴判罪20
		zhansha = 20
		--elseif IsSpellKnown(322109) then	--轮回之触
		--zhansha = 15
		else
		zhansha = 0
		end
	else
		zhansha = PlateColorDB.KillPer
	end
		if not unitFrame.killline then
		unitFrame.killline = unitFrame.healthBar:CreateTexture(nil, "OVERLAY")
		unitFrame.killline:SetSize(2, height)	
		unitFrame.killline:SetTexture("Interface\\Buttons\\WHITE8x8")
		else
		unitFrame.killline:SetPoint("LEFT",unitFrame.healthBar,"LEFT",zhansha*width/100, 0)
		if zhansha == 0 or PlateColorDB.killtexture == false then unitFrame.killline:Hide() else unitFrame.killline:Show() end
		end
	end
end)


--血条变色
local ch = function()
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
   if C_NamePlate.GetNamePlateForUnit(unitFrame.unit) ~= C_NamePlate.GetNamePlateForUnit("player") and not UnitIsPlayer(unitFrame.unit) and not CompactUnitFrame_IsTapDenied(unitFrame) then
	  local threat = UnitThreatSituation("player", unitFrame.unit) or 0
	  local reaction = UnitReaction(unitFrame.unit, "player")
	  local name = UnitName(unitFrame.unit)
	  local me = UnitName("player")
	  local pt = UnitIsUnit(unitFrame.unit.."target", me)
	  local Cur = UnitHealth(unitFrame.unit)
	  local Max = UnitHealthMax(unitFrame.unit)
	  local Per = Cur/Max*100
	  local guid = UnitGUID(unitFrame.unit)
	  local _, _, _, _, _, id = strsplit("-", guid or "") 
	  local combat = UnitAffectingCombat(unitFrame.unit)
	    if id == "120651" then --邪能炸药
			r, g, b = 0,1,0	--绿色
		elseif ((id == "134389") or (id == "134390") or (id == "174773")or (id == "170483")) and pt == true and PlateColorDB.ch == true then
			r, g, b = PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b	--目标是你但是无仇恨预警
		elseif threat == 3  and PlateColorDB.ch == true then
            r, g, b = PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b	-- 仇恨是你 颜色
		elseif threat == 2 and PlateColorDB.ch == true then      
            r, g, b = PlateColorDB.color.rgb3.r,PlateColorDB.color.rgb3.g,PlateColorDB.color.rgb3.b	--仇恨降低  颜色
        elseif threat == 1 and PlateColorDB.ch == true then      
            r, g, b = PlateColorDB.color.rgb4.r,PlateColorDB.color.rgb4.g,PlateColorDB.color.rgb4.b	-- 高仇恨  颜色
		elseif Per <=  PlateColorDB.KillPer then
			r, g, b = PlateColorDB.color.rgb7.r,PlateColorDB.color.rgb7.g,PlateColorDB.color.rgb7.b	--斩杀
		elseif UnitIsUnit(unitFrame.displayedUnit, "target") and PlateColorDB.mytarget == true then
			r, g, b = PlateColorDB.color.rgb5.r,PlateColorDB.color.rgb5.g,PlateColorDB.color.rgb5.b	-- 你的目标 颜色
		elseif combat == true then
			r, g, b = PlateColorDB.color.rgb1.r,PlateColorDB.color.rgb1.g,PlateColorDB.color.rgb1.b	--战斗状态
		elseif reaction == 4 then
			r, g, b = 1, 1, 0		-- 中立怪 黄色
		elseif reaction >= 5 then
			r, g, b = 0, 1, 0		-- 友方npc 绿色
        else
			r, g, b = PlateColorDB.color.rgb0.r,PlateColorDB.color.rgb0.g,PlateColorDB.color.rgb0.b
        end
      unitFrame.healthBar:SetStatusBarColor(r, g, b, 1)
   end
end
end

hooksecurefunc("CompactUnitFrame_IsOnThreatListWithPlayer", ch)
hooksecurefunc("CompactUnitFrame_UpdateHealth", ch)



--名字变色(针对特殊怪)
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
if PlateColorDB.namecolor == false then return end
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
	local unitFrame = namePlate.UnitFrame
	local _,_,_,_,_,_,_,_,_,buff1 = UnitBuff(unitFrame.unit,1)
	local _,_,_,_,_,_,_,_,_,buff2 = UnitBuff(unitFrame.unit,2)
	local _,_,_,_,_,_,_,_,_,buff3 = UnitBuff(unitFrame.unit,3)
	local _,_,_,_,_,_,_,_,_,buff4 = UnitBuff(unitFrame.unit,4)
	local guid = UnitGUID(unitFrame.unit)
	local _, _, _, _, _, id = strsplit("-", guid or "")
	if id == "174773" then
	unitFrame.name:SetTextColor(PlateColorDB.color.rgb6.r,PlateColorDB.color.rgb6.g,PlateColorDB.color.rgb6.b,1)
	end
	if (buff1 or buff2 or buff3 or buff4) == 343502 then
	unitFrame.name:SetTextColor(PlateColorDB.color.rgb6.r,PlateColorDB.color.rgb6.g,PlateColorDB.color.rgb6.b,1)
	end
	end
end)
--血条放大与缩小
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local guid = UnitGUID(unitFrame.unit)
		local _, _, _, _, _, id = strsplit("-", guid or "") 
		if id == "5925" or id == "105451" or id == "105427" or id == "61245" then	--图腾
		unitFrame.healthBar:SetHeight(30)
		end
		if id == "165108" then	--仙林BOSS小怪
		unitFrame.healthBar:SetHeight(6)
		unitFrame.name:Hide()
		end

	end
end)

local casttarget = function()
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local frame = namePlate.UnitFrame
if frame:IsForbidden() then return end
if frame:GetName() then return end
if UnitName(frame.unit) == UnitName("Player") then return end	----防止自身
if frame then
local namea = UnitName(frame.unit.."target")
local myname = UnitName("Player")
local players = UnitIsPlayer(frame.unit)
local _, class = UnitClass(frame.unit.."target")
local guid = UnitGUID(frame.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
if not frame.ta then
frame.ta = frame.healthBar:CreateFontString(nil, "ARTWORK")
frame.ta:SetFont(STANDARD_TEXT_FONT, 20, 'OUTLINE')
frame.ta:SetPoint("LEFT",frame,"RIGHT",-60,15)
frame.ta:Hide()
elseif PlateColorDB.sf == true and players == false then
frame.ta:SetText(namea) 
if ( UnitCastingInfo(frame.unit) ~= nil or UnitChannelInfo(frame.unit) ~= nil ) or id == "174773"  then	--and frame.ta:GetText() == myname then
if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
frame.ta:Show()
else
frame.ta:Hide()
end
elseif PlateColorDB.pvp == true and players == true then
if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
frame.ta:SetText(namea)
if frame.ta:GetText() == myname then
frame.ta:Show()
else
frame.ta:Hide()
end
else frame.ta:Hide()
end
end
end
end
hooksecurefunc("CastingBarFrame_OnUpdate", casttarget)

local hp = function(frame)
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local namePlateframe = namePlate.UnitFrame
if namePlateframe:IsForbidden() then return end
if namePlateframe:GetName() then return end
if namePlateframe then
if not namePlateframe.hp then
namePlateframe.hp = namePlateframe.healthBar:CreateFontString(nil, "ARTWORK")
namePlateframe.hp:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
else
local CurHealth = UnitHealth(namePlateframe.unit)
local MaxHealth = UnitHealthMax(namePlateframe.unit)
local fPer = string.format("%d",(CurHealth/MaxHealth*100)).."%"
local fPerr = string.format("%.1f",(CurHealth/MaxHealth*100)).."%"
local fCur = nil
if CurHealth > 10000 then
		fCur = string.format("%.1f",CurHealth/10000).."w"
	else
		fCur = tostring(CurHealth)
end
if PlateColorDB.hpcent then 
namePlateframe.hp:SetPoint("CENTER",5,0)
else
namePlateframe.hp:SetPoint("RIGHT",0,0)
end
namePlateframe.hp:SetScale(PlateColorDB.num)

if PlateColorDB.DetailType == 1 then
namePlateframe.hp:SetText(fCur)
elseif PlateColorDB.DetailType == 2 then
namePlateframe.hp:SetText(fPer)
elseif PlateColorDB.DetailType == 3 then
namePlateframe.hp:SetText(fPerr)
elseif PlateColorDB.DetailType == 4 then
namePlateframe.hp:SetText(fCur.." - "..fPer)
elseif PlateColorDB.DetailType == 5 then
namePlateframe.hp:SetText(fCur.." - "..fPerr)
end

if PlateColorDB.DetailType ~= 0 and UnitName(namePlateframe.unit) ~= UnitName("Player") then
namePlateframe.hp:Show()
else
namePlateframe.hp:Hide()
end
end
end
end
end
hooksecurefunc("CompactUnitFrame_UpdateMaxHealth", hp)
hooksecurefunc("CompactUnitFrame_UpdateHealth", hp)


local powertext = CreateFrame("Frame")
powertext:RegisterEvent("UNIT_POWER_FREQUENT")
powertext:RegisterEvent("NAME_PLATE_UNIT_ADDED")
powertext:SetScript("OnEvent", function(self, event)

for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
local frame = namePlate.UnitFrame
local bar = NamePlateDriverFrame:GetClassNameplateManaBar() 
local power = UnitPower("player")
local powermax = UnitPowerMax("player")
if frame:IsForbidden() then return end
if UnitName(frame.unit) ~= UnitName("Player") then return end
if (not frame.po) and not platecolorselfpowertext and bar then
frame.po = bar:CreateFontString("platecolorselfpowertext", "ARTWORK")
frame.po:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
frame.po:SetPoint("CENTER",0,-1)
end
if platecolorselfpowertext then
platecolorselfpowertext:SetText(power)
platecolorselfpowertext:SetScale(PlateColorDB.mypotext)
if PlateColorDB.po == true and powermax < 200 and bar then
platecolorselfpowertext:Show()
else
platecolorselfpowertext:Hide()
end
end
end
end)
--hooksecurefunc("ClassNameplateBarRogueDruid_UpdateMaxPower", powertext)
--hooksecurefunc("CompactUnitFrame_OnUpdate", powertext)


--光环规则
local function UpdateBuffsRS(self, unit, filter, showAll)
	if 1 == 0 then return end
	if not self.isActive then
		for i = 1, BUFF_MAX_DISPLAY do
			if (self.buffList[i]) then
				self.buffList[i]:Hide();
			else
				break;
			end
		end
		return;
	end
	
	self.unit = unit;
	self.filter = filter;
	self:UpdateAnchor();
	
	if filter == "NONE" then
		for i, buff in ipairs(self.buffList) do
			buff:Hide();
		end
	else
		local buffIndex = 1;
		local StolenBuffNum = 0
		local StolenBuffTextur = nil
		local StolenDuration = 0
		local StolenExpiration = 0

		-- 检测该单位的全部Aura(目前 BUFF_MAX_DISPLAY = 32)
		for i = 1, BUFF_MAX_DISPLAY do
			-- 先检测 可偷取/驱散增益 BUFF, 用于自定的StolenFrame UI 显示
			local name, texture, count, debuffType, duration, expirationTime, caster, canStealOrPurge, nameplateShowPersonal, spellId, _, _, _, nameplateShowAll = UnitAura(unit, i, 'HELPFUL')
			if name then 
				-- print( name, canStealOrPurge )
				if canStealOrPurge then 
					StolenBuffNum = StolenBuffNum + 1
					StolenBuffTextur = texture
					StolenExpiration = expirationTime
					StolenDuration = duration
				end
				
			end			
			-- 再检测 减益DEBUFF, 用于源生buff位置显示, 源码涉及 NamePlateDriverMixin:OnUnitAuraUpdate 里filter逻辑
			local name, texture, count, debuffType, duration, expirationTime, caster, canStealOrPurge, nameplateShowPersonal, spellId, _, _, _, nameplateShowAll = UnitAura(unit, i, filter)
			if name then 
				if buffIndex <= 10 then 
					local flag = false
					-- 默认过滤器
					if nameplateShowAll == true or nameplateShowPersonal == true then
						flag = true
					end

					-- 白名单
					if PlateColorDB["DctAura"] then 
						if PlateColorDB["DctAura"][spellId] then 
							flag = true end 
					end
					-- 只显示我,暴雪默认会显示一些
					if (not (caster == "player" or caster == "pet")) and nameplateShowAll == false then 
						flag = false
					end
					
					if (flag) then
						if (not self.buffList[buffIndex]) then
							-- self.buffList[buffIndex] = CreateFrame("Frame", self:GetParent():GetName() .. "Buff" .. buffIndex, self, "NameplateBuffButtonTemplate");
							self.buffList[buffIndex] = CreateFrame("Frame", nil, self, "NameplateBuffButtonTemplate");
							self.buffList[buffIndex]:SetMouseClickEnabled(false);
							self.buffList[buffIndex].layoutIndex = buffIndex;
							self.buffList[buffIndex].align = "right";
							if PlateColorDB.buffz > 20 then 
								self.buffList[buffIndex]:SetSize(PlateColorDB.buffz,PlateColorDB.buffz)
								self.buffList[buffIndex].Icon:SetPoint("TOPLEFT",self.buffList[buffIndex],"TOPLEFT", 1, -1)
								self.buffList[buffIndex].Icon:SetPoint("BOTTOMRIGHT",self.buffList[buffIndex],"BOTTOMRIGHT", -1, 1)
								self.buffList[buffIndex].Icon:SetTexCoord(0.1, 0.9,0.1 , 0.9)
							end
							self.buffList[buffIndex].Cooldown:SetHideCountdownNumbers(not PlateColorDB["AuraTimer"])
							local regon = self.buffList[buffIndex].Cooldown:GetRegions()
							if regon.GetText then 
								regon:SetFont(STANDARD_TEXT_FONT, 15, nil)  --Default : 15 "OUTLINE"
							end
						end

						local buff = self.buffList[buffIndex];

						buff:SetID(i);
						buff.Icon:SetTexture(texture);

						-- 层数 
						if (count > 1) then
							buff.CountFrame.Count:SetText(count);
							buff.CountFrame.Count:Show();
						else
							buff.CountFrame.Count:Hide();
						end

						CooldownFrame_Set(buff.Cooldown, expirationTime - duration, duration, duration > 0, true);

						buff:Show();
						buffIndex = buffIndex + 1;
					end
				end
			end
		end

		for i = buffIndex, BUFF_MAX_DISPLAY do
			if (self.buffList[i]) then
				self.buffList[i]:Hide();
			end
		end
	end
	self:Layout();
end
--光环相关设置
local framebuff = CreateFrame('Frame') 
framebuff:RegisterEvent("UNIT_AURA")
framebuff:RegisterEvent("NAME_PLATE_UNIT_ADDED")
framebuff:SetScript('OnEvent', function(self, event, namePlateUnitToken)
for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
	local unitFrame = namePlate.UnitFrame
	unitFrame.BuffFrame.UpdateBuffs = UpdateBuffsRS
	if namePlate.UnitFrame.unit == namePlateUnitToken then 
		if PlateColorDB.buffz > 20 then 
		unitFrame.BuffFrame:SetBaseYOffset(PlateColorDB.buffz-18*PlateColorDB.nScale)
		unitFrame.BuffFrame:UpdateAnchor()
		end
		if unitFrame.unit then 
			local buff = unitFrame.BuffFrame
			for i = 1, BUFF_MAX_DISPLAY do
				if buff.buffList[i] then 
					if PlateColorDB.buffz > 20 then 
						--光环大小
						buff.buffList[i]:SetSize(PlateColorDB.buffz,PlateColorDB.buffz)
						buff.buffList[i].Icon:SetPoint("TOPLEFT",buff.buffList[i],"TOPLEFT", 1, -1)
						buff.buffList[i].Icon:SetPoint("BOTTOMRIGHT",buff.buffList[i],"BOTTOMRIGHT", -1, 1)
					end
					if PlateColorDB.bufftext then
					--计时器
					buff.buffList[i].Cooldown:SetHideCountdownNumbers(false)
					--计时器大小
					local regon = buff.buffList[i].Cooldown:GetRegions()
					if regon.GetText then 
						regon:SetFont(STANDARD_TEXT_FONT,15, "OUTLINE")  --Default : 15 "OUTLINE"
					end	
					end
				end
			end
		end
	end	
end
end)
